/***************************************************************************
                          strength.cpp  -  description
                             -------------------
    begin                : Mon Aug 19 2002
    copyright            : (C) 2002 by Stefan Winter
    email                : mail@stefan-winter.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qwidget.h>
#include <qpainter.h>
#include <qpixmap.h>
#include <kstandarddirs.h>
#include <klocale.h>
#include "strength.h"
#include "stuff.h"

extern deviceinfo *information;

Strength::Strength (QWidget * parent):QWidget (parent, "strength")
{
  KStandardDirs finder;
  kdedir = finder.findResourceDir ("data", "kwifimanager/pics/no_card.png");
  kdedir += "kwifimanager/pics/";
  NOT_CON_OFFLINE_ADHOC = new QPixmap (kdedir + "offline.png");
  EXCELLENT = new QPixmap (kdedir + "excellent.png");
  GOOD = new QPixmap (kdedir + "good.png");
  MARGINAL = new QPixmap (kdedir + "marginal.png");
  OOR_MINIMUM = new QPixmap (kdedir + "oor_minimum.png");
  OOR_DOWN = new QPixmap (kdedir + "oor_down.png");
};

void
Strength::paintEvent (QPaintEvent *)
{
  QPainter *strengthpainter = new QPainter (this);
  QString sstrength1 = "%1";
  int tempstrength = information->qual.qual;
  if ((information->mode==2)&&(information->has_range==1))
    tempstrength = (int) tempstrength *92 / (int) information->range.max_qual.qual;
  QString sstrength2 = i18n ("Signal strength: %1");
  if (information->has_freq != 1)
    {
      sstrength1 = sstrength1.arg (i18n ("NOT CONNECTED"));
      strengthpainter->drawPixmap (50, 20, *NOT_CON_OFFLINE_ADHOC);
    }
  else if (information->mode == 1)
    {
      sstrength1 = sstrength1.arg (i18n ("AD-HOC MODE"));
      strengthpainter->drawPixmap (50, 20, *NOT_CON_OFFLINE_ADHOC);
    }
  else if (tempstrength > 45)
    {
      sstrength1 = sstrength1.arg (i18n ("ULTIMATE"));
      strengthpainter->drawPixmap (50, 20, *EXCELLENT);
    }
  else if (tempstrength > 35)
    {
      sstrength1 = sstrength1.arg (i18n ("TOP"));
      strengthpainter->drawPixmap (50, 20, *EXCELLENT);
    }
  else if (tempstrength > 25)
    {
      sstrength1 = sstrength1.arg (i18n ("EXCELLENT"));
      strengthpainter->drawPixmap (50, 20, *EXCELLENT);
    }
  else if (tempstrength > 15)
    {
      sstrength1 = sstrength1.arg (i18n ("GOOD"));
      strengthpainter->drawPixmap (50, 20, *GOOD);
    }
  else if (tempstrength > 5)
    {
      sstrength1 = sstrength1.arg (i18n ("WEAK"));
      strengthpainter->drawPixmap (50, 20, *MARGINAL);
    }
  else if (tempstrength > 0)
    {
      sstrength1 = sstrength1.arg (i18n ("MINIMUM"));
      strengthpainter->drawPixmap (50, 20, *OOR_MINIMUM);
    }
  else if ((tempstrength == 0) && (information->mode == 2))
    {
      sstrength1 = sstrength1.arg (i18n ("OUT OF RANGE"));
      strengthpainter->drawPixmap (50, 20, *OOR_DOWN);
    }
  else
    {
      sstrength1 = sstrength1.arg (i18n ("N/A"));
      strengthpainter->drawPixmap (50, 20, *NOT_CON_OFFLINE_ADHOC);
    };
  if (information->has_freq == 1)
    {
      if (information->mode == 2)
	{
	  sstrength2 = sstrength2.arg (information->qual.qual);
	}
      else
	sstrength2 = sstrength2.arg (i18n ("N/A"));
    }
  else
    sstrength2 = sstrength2.arg (i18n ("N/A"));
  strengthpainter->drawText (5, 70, sstrength1);
  strengthpainter->drawText (5, 90, sstrength2);
  delete strengthpainter;
}
